; Build this  template with "CONSOLE ASSEMBLE AND LINK"

INCLUDE \masm32\include\masm32rt.inc

INCLUDELIB D:\ASM\MASM32\LIBRARIES\Agner_Fog_AsmLib\alibcof32.lib
; Agner Fogs AsmLib that is available at:
;   http://www.agner.org/optimize/#asmlib
; You can't beat his code for determining which instruction set is
; supported by the processor.

.686
;.XMM    ; the cvttsd2si SSE2 instruction requires this directive
         ; and requires ML 6.15 or later. ML 6.14 can use the
         ; equivalent opcodes.

InstructionSet PROTO C

FISTTP MACRO adr:REQ
    ;; This macro is for MASM 6.x and 7x. If you are using
    ;; MASM 8.0 you don't need this MACRO.
    ;; FISTTP is only available on CPUs that support SSE3.
    LOCAL x,y
    IF (OPATTR(adr)) AND 00010100y  ;; register or const
        .ERR <Invalid operand, dst must be an address in memory!>
    ELSEIF (TYPE (adr) EQ WORD) OR (TYPE (adr) EQ SWORD)
      x:
        fimul adr
      y:
        org  x
        byte 0DFh
        org  y
    ELSEIF (TYPE (adr) EQ DWORD) OR (TYPE (adr) EQ SDWORD)
      x:
        fimul adr
      y:
        org  x
        byte 0DBh
        org  y
    ELSEIF (TYPE (adr) EQ QWORD)
      x:
        fmul adr
      y:
        org  x
        byte 0DDh
        org  y
    ELSE
        .ERR <Invalid operand, dst can be 2, 4 or 8 bytes address only!>
    ENDIF
ENDM

.DATA

    ALIGN 8
    dbl1    REAL8   1.5
    int1    SDWORD  0

.CODE
;----------------------------------------------------
TruncateSSE3 PROC pR8:PTR REAL8, pInt32:PTR SDWORD
    ; This procedure requires SSE3 support
    mov edx, pR8
    mov eax, pInt32
    fld REAL8 PTR [edx]
    FISTTP SDWORD PTR [eax]
    ret
TruncateSSE3 ENDP
;----------------------------------------------------
TruncateSSE2 PROC pR8:PTR REAL8, pInt32:PTR SDWORD
    ; This procedure requires SSE2 support
    mov edx, pR8
    mov ecx, pInt32
    ;cvttsd2si eax, REAL8 PTR [edx]   ; the cvttsd2si SSE2 instruction requires ML 6.15 or later
    DB 0F2h,0Fh,02Ch,02               ; ML 6.14 can use equivalent opcodes.
    mov DWORD PTR [ecx], eax
    ret
TruncateSSE2 ENDP
;----------------------------------------------------
Truncate PROC pR8:PTR REAL8, pInt32:PTR Int32
    LOCAL cwOld:WORD
    LOCAL cwNew:WORD
    fstcw cwOld               ; store FPU control word to cwOld
    mov ax, cwOld             ; copy cwOld to ax
    or ax, 0C00h              ; modify ax for rounding = truncate
    mov cwNew, ax             ; copy ax to cwNew
    fldcw cwNew               ; load cwNew to FPU control word, rounding = truncate
    mov edx, pR8
    mov eax, pInt32
    fld REAL8 PTR [edx]
    fistp SDWORD PTR [eax]
    fldcw cwOld               ; load original control word, set original rounding
    ret
Truncate ENDP
;----------------------------------------------------
main PROC
    print chr$(13,10)
    INVOKE InstructionSet
    .IF eax >= 5      ; SSE3 supported by processor and operating system
        INVOKE TruncateSSE3, ADDR dbl1, ADDR int1
        print chr$("(using SSE3)")
    .ELSEIF eax == 4  ; SSE2 supported by processor and operating system
        INVOKE TruncateSSE2, ADDR dbl1, ADDR int1
        print chr$("(using SSE2)")
    .ELSE
        INVOKE Truncate, ADDR dbl1, ADDR int1
    .ENDIF
    print chr$(" result = ")
    print sdword$(int1)
    print chr$(13,10)
    inkey chr$(13,10,"Press any key to exit ... ")
    print chr$(13,10)
    ret
main ENDP
;----------------------------------------------------
start:

    call main
    exit

END start
